--
-- @Autor: WarezLine
-- @Version 1.0.0

-- =========================================================================== --
-- Multi cheat para modificar capacidad de carga.
-- =========================================================================== --
MC_Carga = {};
MC_Carga.ModName = g_currentModName;

function MC_Carga.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(FillUnit, specializations)
end

function MC_Carga.registerEventListeners(vehicleType)
    for _,e in pairs({"onLoad","onDraw","saveToXMLFile","onRegisterActionEvents"}) do
        SpecializationUtil.registerEventListener(vehicleType, e, MC_Carga)
    end
end

function MC_Carga:onRegisterActionEvents(isSelected, isOnActiveVehicle)
    if isOnActiveVehicle and isSelected and g_currentMission.controlledVehicle ~= nil then
        local _, actionEventId = self:addActionEvent(g_inputBinding, 'KEYCARGA', self, MC_Carga.Activar, false, true, false, true, nil)
        g_inputBinding:setActionEventTextPriority(actionEventId, 2);
	end
end

function MC_Carga:Activar(actionName, keyStatus, arg3, arg4, arg5)
    if self.spec_fillUnit ~= nil and self.spec_fillUnit.fillUnits ~= nil then
        self.xFactor = (self.xFactor + 1)
        if self.xFactor > 10 then self.xFactor = 1 end;
        for i,obj in pairs(self.spec_fillUnit.fillUnits) do
            if obj.MC_capacity == nil then obj.MC_capacity = obj.capacity; end;
			if obj.showOnHud then
				obj.capacity = obj.MC_capacity * self.xFactor 
			end
        end
	end
end

function MC_Carga:onLoad(savegame)
    self.xFactor = 1;
    if savegame ~= nil then
        local key = savegame.key .. ".MC_Carga"		
        local iFactor = getXMLInt(savegame.xmlFile, key.."#XFactor")
        if iFactor ~= nil and iFactor > 1 and iFactor < 11 then
            self.xFactor = iFactor
        end
    end
    if self.spec_fillUnit ~= nil and self.spec_fillUnit.fillUnits ~= nil then
        for _,obj in pairs(self.spec_fillUnit.fillUnits) do
            obj.MC_capacity=obj.capacity
            obj.capacity = obj.capacity * self.xFactor
        end
	end
end

function MC_Carga:saveToXMLFile(xmlFile, key)
    if self.xFactor ~= 1 then
        setXMLInt(xmlFile, key.."#XFactor", self.xFactor)
    end
end

function MC_Carga:onDraw(isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
	if isActiveForInput then
        for i,obj in pairs(self.spec_fillUnit.fillUnits) do
			if obj.showOnHud then
				g_currentMission:addExtraPrintText(string.format(g_i18n.modEnvironments[MC_Carga.ModName].texts.Capacidad, self.xFactor, obj.capacity));
			end
        end
	end
end
